<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">

  <!-- Google Font: Source Sans Pro -->
  <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
  <!-- Font Awesome -->
  <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
  <!-- Select2 -->
  <link rel="stylesheet" href="plugins/select2/css/select2.min.css">
  <!-- Theme style -->
  <link rel="stylesheet" href="dist/css/adminlte.min.css">
  
  <!-- Import Datatable sau jquery -->
  <!-- Import them style bootstrap cho datatable -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
</head>
<body class="hold-transition sidebar-mini">
<!-- Site wrapper -->
<div class="wrapper">
  <!-- Navbar -->
  <nav class="main-header navbar navbar-expand navbar-white navbar-light">
    <!-- Left navbar links -->
    <ul class="navbar-nav">
      <li class="nav-item">
        <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="index3.html" class="nav-link">Home</a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="#" class="nav-link">Quản lý Đơn hàng</a>
      </li>
    </ul>
  </nav>
  <!-- /.navbar -->

  <!-- Main Sidebar Container -->
  <aside class="main-sidebar sidebar-dark-primary elevation-4">
    <!-- Brand Logo -->
    <a href="index3.html" class="brand-link">
      <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3" style="opacity: .8">
      <span class="brand-text font-weight-light">Task 49.10</span>
    </a>

    <!-- Sidebar -->
    <div class="sidebar">
      <!-- Sidebar user (optional) -->
      <div class="user-panel mt-3 pb-3 mb-3 d-flex">
        <div class="image">
          <img src="dist/img/user2-160x160.jpg" class="img-circle elevation-2" alt="User Image">
        </div>
        <div class="info">
          <a href="#" class="d-block">Hieu Nguyen</a>
        </div>
      </div>


      <!-- Sidebar Menu -->
      <nav class="mt-2">
        <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
          <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
          <li class="nav-item menu-open">
            <a href="#" class="nav-link active">
              <i class="nav-icon fas fa-tachometer-alt"></i>
              <p>
                Dashboard
                <i class="right fas fa-angle-left"></i>
              </p>
            </a>
            <ul class="nav nav-treeview">
              <li class="nav-item">
                <a href="#" class="nav-link active">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Quản lý Đơn hàng</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="index2.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Dashboard v2</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="index3.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Dashboard v3</p>
                </a>
              </li>
            </ul>
          </li>
        </ul>
      </nav>
      <!-- /.sidebar-menu -->
    </div>
    <!-- /.sidebar -->
  </aside>

  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1>Quản lý Đơn hàng</h1>
          </div>
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item"><a href="#">Home</a></li>
              <li class="breadcrumb-item active">Quản lý Đơn hàng</li>
            </ol>
          </div>
        </div>
      </div><!-- /.container-fluid -->
    </section>

    <!-- Main content -->
    <section class="content">
      <div class="jumbotron container py-2">
        <h5>Lọc Đơn hàng</h5>
        <div class="row">
          <div class="col-sm-5">
            <div class="row form-group">
              <div class="col-sm-4">
                <label>Loại Pizza</label>
              </div>
              <div class="col-sm-8">
                <select id="select-filter-loaiPizza" class="form-control select-loaiPizza w-100">
                  <option value="">(all)</option>
                </select>
              </div>
            </div>
          </div>
          <div class="col-sm-5">
            <div class="row form-group">
              <div class="col-sm-4">
                <label>Trạng thái</label>
              </div>
              <div class="col-sm-8">
                <select id="select-filter-trangThai" class="form-control select-trangThai w-100">
                  <option value="">(all)</option>
                </select>
              </div>
            </div>
          </div>
          <div class="col-sm-2">
            <button id="btn-filter-order" class="btn btn-info">Lọc</button>
          </div>
        </div>
      </div>
      <div class="container">
        <div class="row">
          <button id="btn-add-order" class="btn btn-success"><i class="fa fa-plus"></i> Thêm Đơn</button>
        </div>
      </div>
      <div class="container">
        <h4 class="text-center">Danh sách Đơn hàng</h4>
        <table class="table table-bordered table-striped table-hover" id="table-orders">
          <thead>
            <tr>
              <th>Mã order</th>
              <th>Size</th>
              <th>Loại pizza</th>
              <th>Đồ uống</th>
              <th>Giá</th>
              <th>Họ và Tên</th>
              <th>Số ĐT</th>
              <th>Trạng thái</th>
              <th>Chi tiết</th>
            </tr>
          </thead>
        </table>
      </div>
      <!--Modal add order-->
      <div>
        <div id="modal-add-order" class="modal fade">
          <div class="modal-dialog modal-xl" style="max-width:900px">
            <div class="modal-content">
              <div class="modal-header">
                <h5 class="modal-title">Thêm Đơn</h5>
                <button class="close" data-dismiss="modal">&times;</button>
              </div>
              <div class="modal-body">
                <form>
                  <div class="row form-group">
                    <label class="col-sm-2 col-form-label">Cỡ Combo</label>
                    <div class="col-sm-4">
                      <select id="select-add-order-size" class="form-control select-size w-100"></select>
                    </div>
                    <label class="col-sm-2 col-form-label">Đường kính</label>
                    <div class="col-sm-4">
                      <input id="inp-add-order-diameter" type="text" class="form-control" disabled> 
                    </div>
                  </div>
                  <div class="row form-group">
                    <label class="col-sm-2 col-form-label">Sườn (miếng)</label>
                    <div class="col-sm-4">
                      <input id="inp-add-order-suon" type="text" class="form-control" disabled>
                    </div>
                    <label class="col-sm-2 col-form-label">Salad</label>
                    <div class="col-sm-4">
                      <input id="inp-add-order-salad" type="text" class="form-control" disabled> 
                    </div>
                  </div>
                  <div class="row form-group">
                    <label class="col-sm-2 col-form-label">Số đồ uống</label>
                    <div class="col-sm-4">
                      <input id="inp-add-order-so-nuoc-uong" type="text" class="form-control" disabled>
                    </div>
                    <label class="col-sm-2 col-form-label">Thành tiền</label>
                    <div class="col-sm-4">
                      <input id="inp-add-order-price" type="text" class="form-control" disabled> 
                    </div>
                  </div>
                  <div class="row form-group">
                    <label class="col-sm-2 col-form-label">Loại pizza</label>
                    <div class="col-sm-4">
                      <select id="select-add-order-loaiPizza" class="form-control select-loaiPizza w-100">
                        <option value="">Chọn Loại Pizza</option>
                      </select>
                    </div>
                    <label class="col-sm-2 col-form-label">Đồ uống</label>
                    <div class="col-sm-4">
                      <select id="select-add-order-drink" class="form-control select-drink w-100"></select>
                    </div>
                  </div>
                  <div class="row form-group">
                    <label class="col-sm-2 col-form-label">Họ và tên</label>
                    <div class="col-sm-4">
                      <input type="text" id="inp-add-order-fullname" class="form-control">
                    </div>
                    <label class="col-sm-2 col-form-label">Email</label>
                    <div class="col-sm-4">
                      <input type="text" id="inp-add-order-email" class="form-control">
                    </div>
                  </div>
                  <div class="row form-group">
                    <label class="col-sm-2 col-form-label">Số điện thoại</label>
                    <div class="col-sm-4">
                      <input type="text" id="inp-add-order-dien-thoai" class="form-control">
                    </div>
                    <label class="col-sm-2 col-form-label">Địa chỉ</label>
                    <div class="col-sm-4">
                      <input type="text" id="inp-add-order-dia-chi" class="form-control">
                    </div>
                  </div>
                  <div class="row form-group">
                    <label class="col-sm-2 col-form-label">Mã giảm giá</label>
                    <div class="col-sm-4">
                      <input type="text" id="inp-add-order-voucherId" class="form-control">
                    </div>
                    <label class="col-sm-2 col-form-label">Lời nhắn</label>
                    <div class="col-sm-4">
                      <input type="text" id="inp-add-order-message" class="form-control">
                    </div>
                  </div>
                </form>
              </div>
              <div class="modal-footer">
                <button class="btn btn-secondary" data-dismiss="modal">Cancel</button>
                <button class="btn btn-primary" id="btn-confirm-add-order">Thêm đơn</button>
              </div>
            </div>
          </div>
        </div>
      </div>
      <!--Model order detail-->
      <div>
        <div id="modal-edit-order" class="modal fade" tabindex="-1">
          <div class="modal-dialog modal-xl" style="max-width:900px">
            <div class="modal-content">
              <div class="modal-header">
                <h5 class="modal-title">Order Detail</h5>
                <button class="close" data-dismiss="modal">&times;</button>
              </div>
              <div class="modal-body">
                <form>
                  <div class="row form-group">
                    <label class="col-sm-2 col-form-label">Order Id</label>
                    <div class="col-sm-4">
                      <input id="inp-edit-order-order-id" type="text" class="form-control" disabled>
                    </div>
                    <label class="col-sm-2 col-form-label">Cỡ Combo</label>
                    <div class="col-sm-4">
                      <select id="select-edit-order-size" class="form-control select-size" disabled></select>
                    </div>
                  </div>
                  <div class="row form-group">
                    <label class="col-sm-2 col-form-label">Đường kính</label>
                    <div class="col-sm-4">
                      <input id="inp-edit-order-diameter" type="text" class="form-control" disabled> 
                    </div>
                    <label class="col-sm-2 col-form-label">Sườn (miếng)</label>
                    <div class="col-sm-4">
                      <input id="inp-edit-order-suon" type="text" class="form-control" disabled> 
                    </div>
                  </div>
                  <div class="row form-group">
                    <label class="col-sm-2 col-form-label">Loại pizza</label>
                    <div class="col-sm-4">
                      <select id="select-edit-order-loaiPizza" type="text" class="form-control select-loaiPizza" disabled></select>
                    </div>
                    <label class="col-sm-2 col-form-label">Salad</label>
                    <div class="col-sm-4">
                      <input id="inp-edit-order-salad" type="text" class="form-control" disabled> 
                    </div>
                  </div>
                  <div class="row form-group">
                    <label class="col-sm-2 col-form-label">Đồ uống</label>
                    <div class="col-sm-4">
                      <select class="form-control select-drink" id="select-edit-order-drink" disabled>
                      </select>
                    </div>
                    <label class="col-sm-2 col-form-label">Số đồ uống</label>
                    <div class="col-sm-4">
                      <input id="inp-edit-order-so-nuoc-uong" type="text" class="form-control" disabled> 
                    </div>
                  </div>
                  <div class="row form-group">
                    <label class="col-sm-2 col-form-label">Mã Voucher</label>
                    <div class="col-sm-4">
                      <input id="inp-edit-order-voucher" type="text" class="form-control" disabled> 
                    </div>
                  </div>
                  <div class="row form-group">
                    <label class="col-sm-2 col-form-label">Thành tiền</label>
                    <div class="col-sm-4">
                      <input id="inp-edit-order-price" type="text" class="form-control" disabled> 
                    </div>
                    <label class="col-sm-2 col-form-label">Giảm giá</label>
                    <div class="col-sm-4">
                      <input id="inp-edit-order-discount" type="text" class="form-control" disabled> 
                    </div>
                  </div>
                  <div class="row form-group">
                    <label class="col-sm-2 col-form-label">Họ và tên</label>
                    <div class="col-sm-4">
                      <input id="inp-edit-order-fullname" type="text" class="form-control" disabled> 
                    </div>
                    <label for="" class="col-sm-2 col-form-label">Email</label>
                    <div class="col-sm-4">
                      <input id="inp-edit-order-email" type="email" class="form-control" disabled> 
                    </div>
                  </div>
                  <div class="row form-group">
                    <label class="col-sm-2 col-form-label">Số điện thoại</label>
                    <div class="col-sm-4">
                      <input id="inp-edit-order-mobile" type="text" class="form-control" disabled>
                    </div>
                    <label class="col-sm-2 col-form-label">Địa chỉ</label>
                    <div class="col-sm-4">
                      <input id="inp-edit-order-address" type="text" class="form-control" disabled> 
                    </div>
                  </div>
                  <div class="row form-group">
                    <label class="col-sm-2 col-form-label">Lời nhắn</label>
                    <div class="col-sm-4">
                      <input id="inp-edit-order-message" class="form-control" disabled></input>
                    </div>
                    <label class="col-sm-2 col-form-label">Trạng thái đơn</label>
                    <div class="col-sm-4">
                      <select id="select-edit-order-status"  class="form-control select-trangThai"></select> 
                    </div>
                  </div>
                  <div class="row form-group">
                    <label class="col-sm-2 col-form-label">Ngày tạo đơn</label>
                    <div class="col-sm-4">
                      <input id="inp-edit-order-create-date" type="text" class="form-control" disabled>
                    </div>
                    <label class="col-sm-2 col-form-label">Ngày cập nhật</label>
                    <div class="col-sm-4">
                      <input id="inp-edit-order-update-date" type="text" class="form-control" disabled> 
                    </div>
                  </div>
                </form>
              </div>
              <div class="modal-footer">
                <button class="btn btn-success mr-1" id="btn-confirm-edit-order">Confirm</button>
                <button class="btn btn-info" data-dismiss="modal">Cancel</button>
              </div>
            </div>
          </div>
        </div>
      </div>
      <!-- Modal confirm delete grade  -->
      <div>
        <div class="modal fade" tabindex="-1" id="modal-delete-order">
          <div class="modal-dialog modal-dialog-centered">
            <div class="modal-content">
              <div class="modal-header">
                <h5 class="modal-title" id="h5-modal-title">Xác nhận xóa Đơn</h5>
                <button class="close" data-dismiss="modal">&times;</button>
              </div>
              <div class="modal-body">
                <label>Bạn có chắc chắn muốn xóa Đơn này không?</label>
              </div>
              <div class="modal-footer">
                <button class="btn btn-danger" id="btn-confirm-delete-order">Xóa Đơn</button>
                <button class="btn btn-secondary" data-dismiss="modal">Cancel</button>
              </div>
            </div>
          </div>
        </div>
      </div>
    </section>
    <!-- /.content -->
  </div>
  <!-- /.content-wrapper -->

  <footer class="main-footer">
    <div class="float-right d-none d-sm-block">
      <b>Version</b> 3.2.0
    </div>
    <strong>Copyright &copy; 2014-2021 <a href="https://adminlte.io">AdminLTE.io</a>.</strong> Task 49.10 02-07-2022.
  </footer>
</div>
<!-- ./wrapper -->

<!-- jQuery -->
<script src="plugins/jquery/jquery.min.js"></script>
<!-- Bootstrap 4 -->
<script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
<!-- Select2 -->
<script src="plugins/select2/js/select2.full.min.js"></script>

<script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
<script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
<!-- AdminLTE App -->
<script src="dist/js/adminlte.min.js"></script>
<!-- AdminLTE for demo purposes -->
<script src="dist/js/demo.js"></script>
</body>
<script>
  "use strict";
  /*** VÙNG 1: BIẾN TOÀN CỤC ***/
  var gBASE_URL = "http://42.115.221.44:8080/devcamp-pizza365";
  var gOrders = [];
  var gColNameList = ["orderId", "kichCo", "loaiPizza", "idLoaiNuocUong", "thanhTien", "hoTen", "soDienThoai", "trangThai", "detail"];
  const gCOL_ORDER_ID = 0;
  const gCOL_KICH_CO = 1;
  const gCOL_LOAI_PIZZA = 2;
  const gCOL_NUOC_UONG = 3;
  const gCOL_THANH_TIEN = 4;
  const gCOL_HO_TEN = 5;
  const gCOL_SO_DIEN_THOAI = 6;
  const gCOL_TRANG_THAI = 7;
  const gCOL_DETAIL = 8;
  var gOrderTable = $("#table-orders").DataTable({
    columns: [
      {data: gColNameList[gCOL_ORDER_ID]},
      {data: gColNameList[gCOL_KICH_CO]},
      {data: gColNameList[gCOL_LOAI_PIZZA]},
      {data: gColNameList[gCOL_NUOC_UONG]},
      {data: gColNameList[gCOL_THANH_TIEN]},
      {data: gColNameList[gCOL_HO_TEN]},
      {data: gColNameList[gCOL_SO_DIEN_THOAI]},
      {data: gColNameList[gCOL_TRANG_THAI]},
      {data: gColNameList[gCOL_DETAIL]},
    ],
    columnDefs: [
      {
        targets: gCOL_DETAIL,
        defaultContent: `
          <div class="d-inline-flex">
            <button class="btn btn-link btn-edit-order" title='Chi tiết'><i class='far fa-edit'></i></button>
            <button class="btn btn-link btn-delete-order" title="Xóa"><i class="fas fa-trash-alt text-danger"></i></button>
          </div>
        `
      }
    ]
  });
  var gSelectedMenuStructure = { // biến lưu trữ combo được chọn
    menuName: "",    // S, M, L
    duongKinhCM: 0,
    suonNuong: 0,
    saladGr: 0,
    drink: 0,
    priceVND: 0
  };
  var gId = 0;
  var gOrderId = "";

  /*** VÙNG 2: GÁN SỰ KIỆN CHO CÁC PHẦN TỬ ***/
  $(document).ready(function(){
    callAjaxApiGetOrderList();
    loadDataToTable(gOrders);
    callAjaxApiGetDrinkList();
    loadDataToSelectSize();
    loadDataToSelectLoaiPizza();
    loadDataToSelectTrangThai();
  })
  $("#btn-filter-order").click(onBtnFilterOrderClick)
  $("#btn-add-order").on("click", onBtnAddOrderClick)
  $("#table-orders").on("click", ".btn-edit-order", function(){
      onBtnEditOrderClick(this)
  });
  $("#table-orders").on("click", ".btn-delete-order", function(){
      onBtnDeleteOrderClick(this)
  });
  $("#btn-confirm-add-order").on("click", onBtnConfirmAddOrderClick)
  $("#btn-confirm-edit-order").on("click", onBtnConfirmEditOrderClick)
  $("#btn-confirm-delete-order").on("click", onBtnConfirmDeleteOrderClick)
  $(".select-size").on("change", function() {
    onSelectSizeChange(this.value)
  })

  /*** VÙNG 3: HÀM XỬ LÝ SỰ KIỆN ***/
  function onBtnFilterOrderClick() {
    var vDataToFilter = {
      loaiPizza: "",
      trangThai: ""
    }
    //B1: đọc dữ liệu
    getDataToFilter(vDataToFilter);
    console.log("Dữ liệu cần lọc là");
    console.log(vDataToFilter);
    //B2: kiểm tra dữ liệu
    //B3: lọc dữ liệu
    var vFilteredOrderList = filterOrder(vDataToFilter);
    console.log("Các đơn hàng đã lọc được là:");
    console.log(vFilteredOrderList)
    //B4: hiển thị dữ liệu
    loadDataToTable(vFilteredOrderList)
  }
  function onBtnAddOrderClick() {
    $("#modal-add-order").modal("show");
  }
  function onBtnEditOrderClick(paramButtonElement) {
    "use strict";
    $("#modal-edit-order").modal("show");
    var vCurrentRow = $(paramButtonElement).closest("tr");
    var vRowData = gOrderTable.row(vCurrentRow).data();
    gId = vRowData.id;
    gOrderId = vRowData.orderId;
    console.log("Nút Sửa được ấn. Id = " + gId + ". Order Id = " + gOrderId);
    loadDataToModalEditOrder(vRowData);
  }
  function onBtnDeleteOrderClick(paramButtonElement) {
    "use strict";
    $("#modal-delete-order").modal("show");
    var vCurrentRow = $(paramButtonElement).closest("tr");
    var vRowData = gOrderTable.row(vCurrentRow).data();
    gId = vRowData.id;
    gOrderId = vRowData.orderId;
    console.log("Nút Xóa được ấn. Id = " + gId + ". Order Id = " + gOrderId);
  }
  function onBtnConfirmAddOrderClick() {
    var vOrderObjToAdd = {};
    //bước 1: lấy dữ liệu từ các input
    getDataFromModalAddOrder(vOrderObjToAdd);
    console.log("Ghi tạm đối tượng dữ liệu ra console");
    console.log(vOrderObjToAdd);
    //bước 2: kiểm tra dữ liệu lấy từ các input
    var vCheckResult = validateOrderData(vOrderObjToAdd);
    console.log("Kết quả kiểm tra dữ liệu là: " + vCheckResult);
    if (vCheckResult == true) {
    //bước 3: tạo order mới
      var vDiscount = getDiscount(vOrderObjToAdd.idVourcher); // lấy phần trăm giảm giá
      if (vDiscount != 0) {
        var vGiaGiam = vOrderObjToAdd.thanhTien * (vDiscount / 100); // tính giá tiền giảm
        var vConLai = vOrderObjToAdd.thanhTien - vGiaGiam;
        console.log("Tìm thấy mã voucher. Bạn được giảm: " + vDiscount + "%."
          + "\n\nGiá tiền được giảm: " + vGiaGiam + " VND."
          + "\n\nTiền còn lại phải thanh toán: " + vConLai + " VND.");
        alert("Tìm thấy mã voucher. Bạn được giảm: " + vDiscount + "%."
          + "\n\nGiá tiền được giảm: " + vGiaGiam + " VND."
          + "\n\nTiền còn lại phải thanh toán: " + vConLai + " VND.");
      }
      callAjaxApiAddOrder(vOrderObjToAdd);
      callAjaxApiGetOrderList();
      loadDataToTable(gOrders);
      resetModalAddOrder();
      $("#modal-add-order").modal("hide")
    }
  }
  function onBtnConfirmEditOrderClick() {
    var vEditRequest = {
      trangThai: "" //3 trang thai open, confirmed, cancel
    } 
    //bước 1: lấy dữ liệu từ các input
    getDataFromModalEditOrder(vEditRequest);
    console.log("Ghi tạm đối tượng dữ liệu ra console");
    console.log(vEditRequest);
    //bước 2: kiểm tra dữ liệu lấy từ các input (bỏ qua)
    //bước 3:  update order data
    callAjaxApiEditOrder(gId, vEditRequest);
    callAjaxApiGetOrderList();
    loadDataToTable(gOrders);
    $("#modal-edit-order").modal("hide")
  }
  function onBtnConfirmDeleteOrderClick() {
    callAjaxApiDeleteOrder(gId);
    callAjaxApiGetOrderList();
    loadDataToTable(gOrders);
    $("#modal-delete-order").modal("hide")
  }
  function onSelectSizeChange(paramSize) {
    if(paramSize == "") {
      $("#inp-add-order-diameter").val("")
      $("#inp-add-order-suon").val("")
      $("#inp-add-order-salad").val("")
      $("#inp-add-order-so-nuoc-uong").val("")
      $("#inp-add-order-price").val("")
      return
    }
    else if(paramSize == "S") {
      var vSelectedMenuStructure = getSize(paramSize, 20, 2, 200, 2, 150000);
    }
    else if(paramSize == "M") {
      var vSelectedMenuStructure = getSize(paramSize, 25, 4, 300, 3, 200000);
    }
    else if(paramSize == "L") {
      var vSelectedMenuStructure = getSize(paramSize, 30, 8, 500, 4, 250000);
    }
    gSelectedMenuStructure = vSelectedMenuStructure; 
    vSelectedMenuStructure.displayInConsoleLog();
    loadSizeInfoToAddOrderModal(vSelectedMenuStructure); // hiển thị dữ liệu của Combo size lên modal
  }
  /*** VÙNG 4: HÀM DÙNG CHUNG ***/
  function callAjaxApiGetOrderList() {
    $.ajax({
      async: false,
      url: gBASE_URL + "/orders",
      type: "GET",
      data: "json",
      success: function(res) {
        gOrders = res;
        console.log(res)
      },
      error: function(err) {
        console.log(err);
        alert("Có lỗi! Xem console")
      }
    })
  }
  function callAjaxApiGetDrinkList() {
    $.ajax({
      async: false,
      url: gBASE_URL + "/drinks",
      type: "GET",
      dataType: 'json',
      success: function(res){
        console.log(res);
        loadDataToSelectDrink(res)
      },
      error: function(err){
        console.log(err);
        alert("Có lỗi! Xem console")
      }
    });
  }
  function loadDataToTable(paramOrderList) {
    $("#table-orders").DataTable()
      .clear()
      .rows.add(paramOrderList)
      .draw()
  }
  function loadDataToSelectDrink(paramDrinkList) {
    $(".select-drink").append($("<option>").val("").text("Chọn Đồ uống"))
    for (let bDrink of paramDrinkList) {
      $(".select-drink").append($("<option>").val(bDrink.maNuocUong).text(bDrink.tenNuocUong))
    }
  }
  function loadDataToSelectSize() {
    $(".select-size")
      .append($("<option>").val("").text("Chọn Cỡ Pizza"))
      .append($("<option>").val("S").text("Nhỏ"))
      .append($("<option>").val("M").text("Vừa"))
      .append($("<option>").val("L").text("Lớn"))
  }        
  function loadDataToSelectLoaiPizza() {
    $(".select-loaiPizza")
      .append($("<option>").val("Seafood").text("Hải sản"))
      .append($("<option>").val("Hawaii").text("Hawaii"))
      .append($("<option>").val("Bacon").text("Thịt hun khói"))
  }
  function loadDataToSelectTrangThai() {
    $(".select-trangThai")
      .append($("<option>").val("open").text("Open"))
      .append($("<option>").val("confirmed").text("Đã xác nhận"))
      .append($("<option>").val("cancel").text("Đã hủy"))
  }
  function loadSizeInfoToAddOrderModal(paramComboObj) {
    $("#inp-add-order-diameter").val(paramComboObj.duongKinhCM)
    $("#inp-add-order-suon").val(paramComboObj.suonNuong)
    $("#inp-add-order-salad").val(paramComboObj.saladGr)
    $("#inp-add-order-so-nuoc-uong").val(paramComboObj.drink)
    $("#inp-add-order-price").val(paramComboObj.priceVND)
  }       
  function getDataFromModalAddOrder(paramOrderObject) {
    paramOrderObject.kichCo = gSelectedMenuStructure.menuName;
    paramOrderObject.duongKinh = gSelectedMenuStructure.duongKinhCM;
    paramOrderObject.suon = gSelectedMenuStructure.suonNuong;
    paramOrderObject.salad = gSelectedMenuStructure.saladGr;
    paramOrderObject.soLuongNuoc = gSelectedMenuStructure.drink;
    paramOrderObject.thanhTien = gSelectedMenuStructure.priceVND
    paramOrderObject.loaiPizza = $("#select-add-order-loaiPizza").val();
    paramOrderObject.idLoaiNuocUong = $("#select-add-order-drink").val();
    paramOrderObject.hoTen = $.trim($("#inp-add-order-fullname").val());
    paramOrderObject.email = $.trim($("#inp-add-order-email").val());
    paramOrderObject.soDienThoai = $.trim($("#inp-add-order-dien-thoai").val());
    paramOrderObject.diaChi = $.trim($("#inp-add-order-dia-chi").val());
    paramOrderObject.loiNhan = $.trim($("#inp-add-order-message").val());
    paramOrderObject.idVourcher = $.trim($("#inp-add-order-voucherId").val());
  }
  function getDataFromModalEditOrder(paramEditRequest) {
    paramEditRequest.trangThai = $("#select-edit-order-status").val();
  }
  function loadDataToModalEditOrder(paramRowData) {
    $("#inp-edit-order-order-id").val(paramRowData.orderId);
    $("#select-edit-order-size").val(paramRowData.kichCo);
    $("#inp-edit-order-diameter").val(paramRowData.duongKinh);
    $("#inp-edit-order-suon").val(paramRowData.suon);
    $("#select-edit-order-loaiPizza").val(paramRowData.loaiPizza);
    $("#inp-edit-order-salad").val(paramRowData.salad);
    $("#select-edit-order-drink").val(paramRowData.idLoaiNuocUong);
    $("#inp-edit-order-so-nuoc-uong").val(paramRowData.soLuongNuoc);
    $("#inp-edit-order-voucher").val(paramRowData.idVourcher);
    $("#inp-edit-order-price").val(paramRowData.thanhTien);
    $("#inp-edit-order-discount").val(paramRowData.giamGia);
    $("#inp-edit-order-fullname").val(paramRowData.hoTen);
    $("#inp-edit-order-email").val(paramRowData.email);
    $("#inp-edit-order-mobile").val(paramRowData.soDienThoai);
    $("#inp-edit-order-address").val(paramRowData.diaChi);
    $("#inp-edit-order-message").val(paramRowData.loiNhan);
    $("#select-edit-order-status").val(paramRowData.trangThai);
    $("#inp-edit-order-create-date").val(paramRowData.ngayTao);
    $("#inp-edit-order-update-date").val(paramRowData.ngayCapNhat);
  }
  function validateOrderData(paramOrderObject) {
    var vCheckResult = false;
    if (paramOrderObject.kichCo == "") {
      console.log("%cChưa chọn cỡ pizza", "color:red");
      alert("Chưa chọn cỡ pizza");
    }
    else if (paramOrderObject.loaiPizza == "") {
      console.log("%cChưa chọn loại pizza", "color:red");
      alert("Chưa chọn loại pizza");
    }
    else if (paramOrderObject.idLoaiNuocUong == "") {
      console.log("%cChưa chọn loại nước uống", "color:red");
      alert("Chưa chọn loại nước uống");
    }
    else if (paramOrderObject.hoTen == "") {
      console.log("%cChưa nhập họ và tên", "color:red");
      alert("Chưa nhập họ và tên");
    }
    else if (validateEmail(paramOrderObject.email) == true) {
      if (validatePhoneNumber(paramOrderObject.soDienThoai) == true) {
        if (paramOrderObject.diaChi == "") {
          console.log("%cChưa nhập địa chỉ", "color:red");
          alert("Chưa nhập địa chỉ");
        }
        else if (paramOrderObject.idVourcher != "" && isNaN(paramOrderObject.idVourcher)) {
          console.log("%cMã giảm giá phải là số", "color:red");
          alert("Mã giảm giá phải là số");
        }
        else {
          vCheckResult = true
        }
      }
    }
    return vCheckResult
  }
  function validateEmail(paramEmail) { // hàm kiểm tra email
    var vCheckResult = true;
    if (paramEmail != "") { //nếu có nhập email thì kiểm tra định dạng email
      var vRegEx = /^\w+([\.-]?\w+)*@\w+([\.-]?\w+)*(\.\w{2,3})+$/;
      if (vRegEx.test(paramEmail) == false) { //nếu định dạng email không đúng thì cảnh báo, không cho pass
        console.log("%cEmail không đúng định dạng", "color:red");
        alert("Email không đúng định dạng");
        vCheckResult = false
      }
    }
    //nếu không nhập email hoặc có nhập email và đúng định dạng thì cho pass 
    return vCheckResult
  }
  function validatePhoneNumber(paramPhoneNumber) { // hàm kiểm tra số điện thoại
    var vCheckResult = false;
    if (paramPhoneNumber == "") {
      console.log("%cChưa nhập số điện thoại", "color:red");
      alert("Chưa nhập số điện thoại");
    }
    else if (isNaN(paramPhoneNumber)) {    
      console.log("%cSố điện thoại phải là dãy số nguyên dương", "color:red");
      alert("Số điện thoại phải là dãy số nguyên dương");
    }
    else {
      var vChuyenSo = Number(paramPhoneNumber);
      if (!Number.isInteger(vChuyenSo) || vChuyenSo <= 0) { 
        console.log("%cSố điện thoại phải là dãy số nguyên dương", "color:red");
        alert("Số điện thoại phải là dãy số nguyên dương");
      }     
      else {
        vCheckResult = true
      }
    }
    return vCheckResult
  }
  function callAjaxApiAddOrder(paramOrderObjToAdd) {
    $.ajax({
      async: false,
      url: gBASE_URL + "/orders",
      type: "POST",
      contentType: "application/json;charset=UTF-8",
      data: JSON.stringify(paramOrderObjToAdd),
      dataType: "json",
      success: function(res) {
        alert("Tạo Đơn mới thành công! Id đơn mới là " + res.id);
        console.log(res)
      },
      error: function(err) {
        console.log(err);
        alert("Có lỗi! Xem console")
      }
    })
  }
  function callAjaxApiEditOrder(paramId, paramEditRequest) {
    $.ajax({
      async: false,
      url: gBASE_URL + "/orders/" + paramId,
      type: "PUT",
      contentType: "application/json",
      data: JSON.stringify(paramEditRequest),
      dataType: "json",
      success: function(res) {
        alert("Cập nhật thành công cho Đơn có Id là " + res.id);
        console.log(res)
      },
      error: function(err) {
        console.log(err);
        alert("Có lỗi! Xem console")
      }
    })
  }
  function callAjaxApiDeleteOrder(paramId) {
    $.ajax({
      async: false,
      url: gBASE_URL + "/orders/" + paramId,
      type: "DELETE",
      dataType: "json",
      success: function(res) {
        alert("Xóa thành công Đơn có Id là " + paramId + "!");
        console.log(res)
      },
      error: function(err) {
        console.log(err);
        alert("Có lỗi! Xem console")
      }
    })
  }
  function resetModalAddOrder() {
    $("#select-add-order-size").val("");
    $("#inp-add-order-diameter").val("")
    $("#inp-add-order-suon").val("")
    $("#inp-add-order-salad").val("")
    $("#inp-add-order-so-nuoc-uong").val("")
    $("#inp-add-order-price").val("")
    $("#select-add-order-loaiPizza").val("");
    $("#select-add-order-drink").val("");
    $("#inp-add-order-fullname").val("");
    $("#inp-add-order-email").val("");
    $("#inp-add-order-dien-thoai").val("");
    $("#inp-add-order-dia-chi").val("");
    $("#inp-add-order-message").val("");
    $("#inp-add-order-voucherId").val("");
  }
  function getSize(paramSize, paramDuongKinhCM, paramSuonNuong, paramSaladGr, paramDrink, paramPriceVND) {
    var vSelectedMenuStructure = {  //Đối tượng: cỡ pizza được chọn
      menuName: paramSize,   //size = S/M/L
      duongKinhCM: paramDuongKinhCM,
      suonNuong: paramSuonNuong,
      saladGr: paramSaladGr,
      drink: paramDrink,
      priceVND: paramPriceVND,
      displayInConsoleLog() {
        console.log("%cPIZZA SIZE SELECTED - cỡ pizza được chọn.....", "color:blue");
        console.log("Size: " + this.menuName + "; Đường kính: " + this.duongKinhCM + " cm"
                + "; Sườn nướng: " + this.suonNuong + "; Salad: " + this.saladGr + " gram"
                + "; Số lượng drink: " + this.drink + "; Giá tiền: " + this.priceVND + " VND");
      }
    }
    return vSelectedMenuStructure;  //trả lại đối tượng, có đủ dữ liệu (attribute) và các methods (phương thức)
  }
  function getDiscount(paramVoucherID) { // hàm lấy phần trăm giảm giá
    var vDiscount = 0;
    if (paramVoucherID == "") {
      console.log("Không nhập voucher ID");
    }
    else { // nếu mã giảm giá đã nhập, tạo request lấy giảm giá
      $.ajax({
        async: false,
        url: "http://42.115.221.44:8080/devcamp-voucher-api/voucher_detail/" + paramVoucherID,
        type: "GET",
        dataType: "json",
        success: function (response) {
          console.log(response);
          if(response.phanTramGiamGia > 0 || response.phanTramGiamGia <= 100) {
            vDiscount = response.phanTramGiamGia;
          }
          else {
            console.log("Voucher không đúng");
            alert("Voucher không đúng")
          }
        },
        error: function(err) {
          console.log("Voucher đã nhập không tồn tại. Lỗi là: ");
          console.log(err);
          alert("Voucher đã nhập không tồn tại");
        }
      })
    }
    return vDiscount
  }
  function getDataToFilter(paramFilterObj) {
    paramFilterObj.loaiPizza = $("#select-filter-loaiPizza").val();
    paramFilterObj.trangThai = $("#select-filter-trangThai").val();
  }
  function filterOrder(paramFilterObj) {
    var vFilteredOrderList = gOrders.filter(function(item) {
      return (
        (paramFilterObj.loaiPizza == "" || item.loaiPizza.toLowerCase().includes(paramFilterObj.loaiPizza.toLowerCase())) &&
        (paramFilterObj.trangThai == "" || item.trangThai.toLowerCase().includes(paramFilterObj.trangThai.toLowerCase()))
      )
    })
    return vFilteredOrderList
  }
</script>
</html>
